#
# $Source: /home/nlfm/Working/Zircon/Development/lib/RCS/dcc.tcl,v $
# $Date: 1996/04/03 09:05:48 $
# $Revision: 1.16.1.17 $
#
global dccInfo
set dccInfo {}
#
proc DCCSend {usr file} {
    if [string match {} $file] return
    if [file exists $file] {
	if ![file readable $file] {
	    mkDialog ERROR .@fe {File error} "Cannot read file $file." {}
	    return
	}
	set file [glob $file]
	set xfile [file tail $file]
	global zircon Offer monitorOut
	if $monitorOut { zOut "! dccsend $file 00 $usr" }
	if [catch {set fd [open "|$zircon(lib)/dccsend $file 00 $usr" r]}] {
	    mkDialog ERROR .@fe {Prog error} "Cannot run DCC \
	      helper program dccsend. Check your installation" {}
	    return
	}
	gets $fd port
	[$usr net] CTCP DCC [$usr name] \
	  "SEND $xfile [ipPack [ipAddress]] [lindex $port 0] [file size $file]"
	if ![info exists Offer($usr)] { $usr ref }
	lappend Offer($usr) [list [lindex $port 1] $file $fd]
	fileevent $fd readable "handleInfo $fd"
	if [winfo exists .@dcclist] buildDCCList
    } {
	mkDialog ERROR .@fe {File error} "File $file does not exist." {}
    }
}
#
proc doDCC {cmd nk} {
    if {$nk != {} && ![string match {[#&]*} $nk]} {[User :: make $nk] dcc $cmd}
}
#
proc closeChat {cht who conn} {
    catch {clearHandler $conn ; close $conn}
    global Chat 
    catch {unset $conn Chat($cht)}
    if ![string match {} [info proc $cht]] {
	$cht addText $who "*** $who has closed the connection"
    }
}
#
proc dccChat {mode conn} {
    global monitorIn
    upvar #0 $conn chdata
    set who [$chdata(who) name]
    set cht $chdata(obj)
    switch $mode {
    r   {
	    if {[catch {gets $conn} buffer] || 
	      ([string match {} $buffer] && [eof $conn])} {
		closeChat $cht $who $conn
	    } {
		if $monitorIn { zIn "= $buffer" }
		regsub -all "\r" $buffer {} buffer
		$cht addText $who "=$who= $buffer"
	    }
	}
    e   {  [$chData(who) net] display {} "*** Error on DCC Chat connection with $who" }
    }
}

proc handleInfo {conn} {
    if {[catch {gets $conn} msg] || ($msg == {} && [eof $conn])} {
	catch {close $conn}
    } {
	global Offer Send Get monitorIn
	if $monitorIn {zIn "! $msg"}
	set sp [split $msg { }]
	set who [lindex $sp 5]
	set pid [lindex $sp 0]
	set msg [join [lreplace [lrange $sp 1 end] 4 4 [$who name]]]
	switch -glob -- $msg {
	{DCC Get conn*} -
	{DCC Send acc*} { return }
	{DCC Send conn*} {
		set x [lsearch $Offer($who) "$pid *"]
		lappend Send($who) [lindex $Offer($who) $x]
		listdel Offer($who) $x
		if [string match {} $Offer($who)] { unset Offer($who) }
		if [winfo exists .@dcclist] buildDCCList
		dccWindow $conn $who
		return
	    }
	{DCC Send prog*} {
		dccProgress $conn [lindex $sp 6]
		return
	    }
	{DCC Send*} -
	{DCCError Send*} {
		set x [lsearch $Send($who) "$pid *"]
		listdel Send($who) $x
		if [string match {} $Send($who)] { unset Send($who) ; $who deref} 
		if [winfo exists .@dcclist] buildDCCList
		catch {destroy .@$conn}
	    }
	{DCCError Get*} -
	{DCC Get*} {
		set x [lsearch $Get($who) "$pid *"]
		listdel Get($who) $x
		if [string match {} $Get($who)] { unset Get($who) ; $who deref}
		if [winfo exists .@dcclist] buildDCCList
	    }
	default {
		set msg "WEIRD ERROR : $msg"
	    }
	}
	mkInfoBox DCCINFO .@dcc$conn {DCC Info} $msg
    }
}
#
proc doGetDCC {net wh usr addr port args} {
    set host [dectonet $addr]
    if ![string compare Chat $wh] {
	if [catch {connect $host $port} sok] {
	    $net display {} "*** Cannot connect to host $host ($sok)"
	    return 0
	}
	catch {chatBuffer $sok}
	global Chat
	upvar #0 $sok chdata
	set chdata(who) $usr
	[set chdata(obj) [set this [Chat [$usr name]]]] show
	$this addUser $chdata(who) 0 0
	set Chat($this) $sok
	handler $sok re dcc${wh}
    } {
	if {[file exists [set file [lindex $args 0]]] && 
	  ![file writable $file]} {
	    mkDialog {} .@fe {File error} "Cannot write file $file." \
	      {} {Dismiss {}}
	    return 0
	}
	global zircon Get monitorOut
	set file [file dirname $file]/[file tail $file]
	if $monitorOut { zOut "! dccget $host $port $file 00 $usr" }
	if [catch {set fd [open "|$zircon(lib)/dccget $host $port $file \
	  00 $usr" r]}] {
	    mkDialog ERROR .@fe {Prog error} "Cannot run DCC \
	      helper program dccget. Check your installation" {} {Dismiss {}}
	    return 0
	} {
	    gets $fd pid
	    fileevent $fd readable "handleInfo $fd"
	    lappend Get($usr) [list $pid $file $fd]
	}
    }
    return 1
}
#
proc dccPick {net win y} {
    global DCCList
    notIdle {}
    if {[set t [$win curselection]] == {}} { set t [$win nearest $y] }
    foreach x $t {
	set l [lindex $DCCList $t]
	set usr [lindex $l 1]
	set addr [lindex $l 2]
	set port [lindex $l 3]
	set fln [lindex $l 4]
	switch [set op [lindex $l 0]] {
	Send {
		set v .@[newName dcc]
		set msg "DCC Send request ($fln) from [$usr name]"
		mkFileBox $v "DCC Send $fln" $msg $fln \
		  "Accept {doGetDCC $net Get $usr $addr $port}" {Reject {}}
		tkwait window $v
	    }
	default { doGetDCC $net $op $usr $addr $port {} }
	}
    }
    foreach x $t {
	catch {$win delete $t $t}
	listdel DCCList $t
    }
    if [string match {} $DCCList] { destroy .@dccreq }
}
#
proc dccDel {net win} {
    notIdle {}
    if {[set t [$win curselection]] != {}} {
	global DCCList
	$win delete [lindex $t 0] [lindex $t end]
	foreach x $t { listdel DCCList $t }
	if [string match {} $DCCList] { destroy .@dccreq }
    }
}
#
proc addDCCRequest {net op usr fln addr port} {
     global DCCList
     if ![winfo exists .@dccreq] {
	set DCCList {}
	toplevel .@dccreq -class Zircon
	wm title .@dccreq {Incoming DCC Requests}
	wm protocol .@dccreq WM_DELETE_WINDOW {}
	makeLB .@dccreq.lb -setgrid 1 -width 40 -height 8 
	pack .@dccreq.lb
	bind .@dccreq.lb.l <Double-Button-1> "dccPick $net %W %y ; break"
	bind .@dccreq.lb.l <Delete> "dccDel  $net %W ; break"
	bind .@dccreq.lb.l <BackSpace> [bind .@dccreq.lb.l <Delete>]
	bind .@dccreq.lb.l <Control-h> [bind .@dccreq.lb.l <Delete>]
	bind .@dccreq.lb <Any-Enter> {focus .@dccreq.lb.l ; notIdle {} ; break}
     }
     .@dccreq.lb.l insert end "[$usr name] : $op $fln"
     popup .@dccreq
     lappend DCCList [list $op $usr $addr $port $fln]
}
#
proc handleDCC {net usr param} {
    set pars [split $param]
    switch -exact -- [lindex $pars 1] {
    SEND {
	    if [string match ".*" [set fln [lindex $pars 2]]] {
		set fln _[string range $fln 1 end]
	    }
	    set addr [lindex $pars 3]
	    set port [lindex $pars 4]
	    addDCCRequest $net Send $usr $fln $addr $port
	}  
    CHAT { addDCCRequest $net Chat $usr {} [lindex $pars 3] [lindex $pars 4]	}
    }
}
#
proc ipPack {ip} {
    set val 0
    foreach x [split $ip "."] {	set val [expr {($val << 8) + $x}] }
    return [format %u $val]
}
#
proc dectonet {dec} {
    if {[string length $dec] == 10 && [set first [string index $dec 0]] > 1} {
	switch -exact -- $first {
	    2 {set overflow "0 148 53 119"}
	    3 {set overflow "0 94 208 178"}
	    4 {set overflow "0 40 107 238"}
	}
	set dec [string range $dec 1 end]
    } else {
	set overflow {0 0 0 0}
    }   

    scan [format "%08x" $dec] "%2x%2x%2x%2x" net(3) net(2) net(1) net(0)

    for {set part 0; set carry 0} {$part < 4} {incr part} {
	set sum [expr {$net($part) + [lindex $overflow $part] + $carry}]
	set internet($part) [expr {$sum % 256}]
	set carry [expr {$sum / 256}]
    }

    return "$internet(3).$internet(2).$internet(1).$internet(0)"
}
#
proc killDel {arr usr file} {
    global $arr
    set i 0
    foreach p [set ${arr}($usr)] {
	if ![string compare [lindex $p 1] $file] {
	    catch {exec kill [lindex $p 0]}
	    listdel ${arr}($usr) $i
	    if [string match {} [set ${arr}($usr)]] {
		unset ${arr}($usr)
		$usr deref
	    }
	    return
	}
	incr i
    }
}
#
proc dccClose {win} {
    foreach t [$win curselection] {
	set x [split [$win get $t]]
	set usr [User :: find [set who [lindex $x 2]]]
	set file [lindex $x 4]
	switch -glob -- [lindex $x 0] {
	{Call to*} {$usr unChat }
	{Call from*} { }
	Chat* {catch {[Chat :: find $who] leave}}
	Offer* { killDel Offer $usr $file }
	Request* { }
	Send* { killDel Send $usr $file }
	Get* { killDel Get $usr $file }
	}
    }
    foreach t [$win curselection] { $win delete $t }
}
#
proc buildDCCList {args} {
    global ztrans
    set w .@dcclist
    if [winfo exists $w] {
	popup $w
	if [string match {} $args] { $w.dcc.l delete 0 end }
    } {
	toplevel $w -class Zircon -relief raised -borderwidth 2
	wm title $w {DCC Connections}
	wm protocol $w WM_DELETE_WINDOW "destroy $w"
	makeLB $w.dcc -setgrid 1
	frame $w.btn
	button $w.btn.ok -text $ztrans(dismiss) -command "destroy $w" -relief raised
	button $w.btn.clear -text $ztrans(close) -relief raised \
	  -command "dccClose $w.dcc.l"
	pack $w.btn.ok $w.btn.clear -side left -expand 1 -fill x
	pack $w.dcc -fill both
	pack $w.btn -fill x
    }
    global AChat Chat Offer Send Get
    foreach nn [array names AChat] { $w.dcc.l insert end "$ztrans(call) - [$nn name]" }
    foreach nn [array names Chat] { $w.dcc.l insert end "$ztrans(chat) - [$nn name]" }

    foreach arr {Offer Send Get} {
	foreach nn [array names $arr] {
	   foreach fl [set ${arr}($nn)] {
		$w.dcc.l insert end "[trans $arr] - [$nn name] : [lindex $fl 1]"
	   }
	}
    }
}
#
proc usersDCC {cmd} {
    global ztrans
    switch $cmd {
    List -
    Close { buildDCCList }
    default {
	    mkEntryBox .@$cmd $cmd "Enter user name for DCC $cmd:" \
	      "{$ztrans(user) {}}" \
	      "$ztrans(ok) {doDCC [string toupper $cmd]}" "$ztrans(cancel) {}"
	}
    }
}
#
proc dccWindow {conn usr} {
    global Send ztrans
    set w .@$conn
    toplevel $w -class Zircon
    set file [lindex $Send($usr) 1]
    wm title $w "DCC send $file to [$usr name]"
    wm protocol $w WM_DELETE_WINDOW {}
    frame $w.meter -relief raised
    scale $w.meter.slide -from 0 -to 100 -tickinterval 10 \
       -state disabled -length 400 -orient horizontal
    pack $w.meter.slide -padx 10 -pady 10 -fill x
    pack $w.meter -fill x 
    button $w.cancel -text $ztrans(cancel) \
      -command "killDel Send {$usr} {$file} ; destroy .@$conn"
    pack $w.cancel -fill x
}
#
proc dccProgress {conn sent} {
    set w .@$conn.meter.slide
    $w configure -state normal
    $w set $sent
    $w configure -state disabled
    update
}
